// Debugging problem Chapter 13: Phone.java
// Program creates a GUI that resembles a phone with functionality.
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Phone extends JFrame {
   private Jbutton keys[];
   private JPanel keyPad, lcd;
   private JTextArea lcdContent;
   private String lcdOutput = "";
   private int count;
   
   // constructor sets up GUI
   public Phone()
   {
      super( "Phone" );
      
      lcdContent = new JTextArea( 4, 15 );
      lcdContent.setEditable( false );
      lcd.add( lcdContent );
      
      keys = new Jbutton[ 15 ];
      
      // initialize all digit key Buttons
      for ( int i = 3; i <= 11; i++ )
         keys[ i ] = new Jbutton( String.valueOf( i - 2 ) );
      
      // initialize all non-digit key Buttons
      keys[ 0 ] = new Jbutton( "Send" );
      keys[ 1 ] = new Jbutton( "clr" );
      keys[ 2 ] = new Jbutton( "End" );
      keys[ 12 ] = new Jbutton( "*" );
      keys[ 13 ] = new Jbutton( "0" );
      keys[ 14 ] = new Jbutton( "#" );
      
      keys[ 0 ].addActionListener(
         
            public void actionPerformed( ActionEvent e ) 
            {
               lcdContent.setText( " " );
               lcdOutput = "Calling...\n\n" + lcdOutput;
               lcdContent.append( lcdOutput );                      
            } // end method actionPerformed
            
         } // end new ActionListener
         
      ) // end addActionListener call
      
      keys[ 1 ].addActionListener(
         
         new ActionListener() {
            
            public void actionPerformed( ActionEvent e ) 
            {
               if ( lcdOutput.length() == 0 ||
                  lcdOutput.substring( 0, 1 ).equals( "C" ) )
                  return;
               else {
                  lcdOutput = lcdOutput.substring( 0, ( lcdOutput.length() - 1 ) );
                  lcdContent.setText( " " );
                  lcdContent.append( lcdOutput );
               } // end else
               
            } // end method actionPerformed
            
         } // end object ActionLstener
         
      ) // end addActionListener call
      
      keys[ 2 ].addActionListener(
         
         new ActionListener() {
            
            public void actionPerformed( ActionEvent e ) 
            {            
               lcdContent.setText( " " );
               lcdOutput = "";
               
            } // end method actionPerformed
            
         } // end new ActionListener
         
      ) // end ActionListener call
          
      for ( int i = 3; i <= 14; i++ ) {
         keys[ i ].addActionListener(
            
            new ActionListener() {
               
               public void actionPerformed( ActionEvent e ) 
               {
                  lcdOutput += e.getActionCommand();

                  if ( lcdOutput.substring( 0, 1 ).equals( "C" ) )
                      return;

                  lcdContent.append( e.getActionCommand() );
               } // end method actionPerformed
               
            } // end new ActionListener
            
         ) // end addActionListener call
         
      } // end for loop
                   
      // set keyPad layout to grid layout
      keyPad = new JPanel();
      keyPad.setLayout( new GridLayout( 5, 3 ) );
      
      // add buttons to keyPad panel
      for ( int i = 0; i <= 14; i++ )
         keyPad.add( keys[ i ] );
      
      // add components to container
      Container container = getContentPane();
      container.add( lcdOutput, BorderLayout.NORTH ); 
      
      setSize( 200, 300 );
      setVisible( true );
      
   } // end Phone constructor
   
   // execute application
   public static void main( String args[] )
   {
      Phone application = new Phone();
      application.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
      
   } // end method main
   
} // end class Phone